/*--------------------------------------------------------------------
  generic module.

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include	"config.h"

#include	<stdio.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<utime.h>
#include	"generic.h"


  /*  misc */

void	strjncpy(char *s,const char *t,size_t ln)
{
	int 	i;
	bool	kf;
	char	*p;

	p=s;
	if (strlen(t)<=ln)
		{
		 strcpy(p,t);
		 return;
		}

	kf=FALSE;
	for (i=0;i<ln-1;++i,++p,++t)
	{
		*p=*t;
		if (kf)
			kf=FALSE; else
			kf=iskanji(*p);
	}

	if (kf|| !iskanji(*t))
		*p++=*t;
	*p='\0';
}

int 	touchfile(const char *path, time_t atime, time_t mtime)
{
	struct utimbuf times;

	times.actime = atime;
	times.modtime = mtime;
	return utime(path, &times);

/*
	struct timeval tvp[2];

	tvp[0].tv_sec = atime;
	tvp[0].tv_usec = 0;
	tvp[1].tv_sec = mtime;
	tvp[1].tv_usec = 0;
	return utimes(path, tvp);
*/
}

bool	mole_dir(const char* s)
{
	const	char	*p;
	char	buf[1024+1];	// !! buf size
	struct	stat	st;

	p=s;
	if (*p=='/')
		++p;

	for(;;)
		{
		 if (*p=='\0'||p==NULL)
		 	return TRUE;
		 p=strchr(p,'/');
		 if (p==NULL)
		 	strcpy(buf,s); else
		 	{
		 	 memcpy(buf,s,p-s);
		 	 buf[p-s]='\0';
		 	 ++p;
		 	}
//fprintf(stderr,"mole_chk[%s]\n",buf);
		 if (stat(buf,&st)==0)
		 	{
		 	 if ((st.st_mode&S_IFMT)==S_IFDIR)
		 	 	continue;
		 	 return FALSE;
		 	}
		 if (mkdir(buf,0777)<0)
		 	return FALSE;
		}
	return TRUE;
}

