/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:setopt.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include "ed.h"
#include "sh.h"
#include <ctype.h>

extern	keydef_t	keydef[MAX_region][MAXKEYDEF];


void	key_set()
{
	int 	n;

// keys_num
	n=keys_num;
	if (n==0)
		{
		 keys_set("[UP]",        "&ku");
		 keys_set("[DOWN]",      "&kd");
		 keys_set("[RIGHT]",     "&kr");
		 keys_set("[LEFT]",      "&kl");
		 keys_set("[HOME]",      "&kh");
		 keys_set("[BS]",        "&kb");
		 keys_set("[DEL]",       "&kD");
		 keys_set("[INS]",       "&kI");
		 keys_set("[Page_Up]",   "&kP");
		 keys_set("[Page_Down]", "&kN");
		 keys_set("[END]",       "&@7");

		 keys_set("[F01]",       "&k1");
		 keys_set("[F02]",       "&k2");
		 keys_set("[F03]",       "&k3");
		 keys_set("[F04]",       "&k4");
		 keys_set("[F05]",       "&k5");
		 keys_set("[F06]",       "&k6");
		 keys_set("[F07]",       "&k7");
		 keys_set("[F08]",       "&k8");
		 keys_set("[F09]",       "&k9");
		 keys_set("[F10]",       "&k0");
		 keys_set("[F11]",       "&ka");
		 keys_set("[F12]",       "&kb");

		 keys_set("[F01]",       "&l1");
		 keys_set("[F02]",       "&l2");
		 keys_set("[F03]",       "&l3");
		 keys_set("[F04]",       "&l4");
		 keys_set("[F05]",       "&l5");
		 keys_set("[F06]",       "&l6");
		 keys_set("[F07]",       "&l7");
		 keys_set("[F08]",       "&l8");
		 keys_set("[F09]",       "&l9");
		 keys_set("[F10]",       "&l0");


		 keys_set("[CR]",        "$?(1b)OM");
		 keys_set("[F01]",       "$?(1b)OP");
		 keys_set("[F02]",       "$?(1b)OQ");
		 keys_set("[F03]",       "$?(1b)OR");
		 keys_set("[F04]",       "$?(1b)OS");
		 keys_set("*",           "$?(1b)Oj");
		 keys_set("+",           "$?(1b)Ok");
		 keys_set(",",           "$?(1b)Ol");
		 keys_set("-",           "$?(1b)Om");
		 keys_set(".",           "$?(1b)On");
		 keys_set("/",           "$?(1b)Oo");
		 keys_set("0",           "$?(1b)Op");
		 keys_set("1",           "$?(1b)Oq");
		 keys_set("2",           "$?(1b)Or");
		 keys_set("3",           "$?(1b)Os");
		 keys_set("4",           "$?(1b)Ot");
		 keys_set("5",           "$?(1b)Ou");
		 keys_set("6",           "$?(1b)Ov");
		 keys_set("7",           "$?(1b)Ow");
		 keys_set("8",           "$?(1b)Ox");
		 keys_set("9",           "$?(1b)Oy");


		 keys_set("[BS]",        "$?(1f)");
		}
	keys_sort();

	n=keydef_num(0);
	if (n==0)
		{
		 keyf_set(0, "^KW",           "file_toggle");
		 keyf_set(0, "[F02]",         "file_toggle");
		 keyf_set(0, "^KT",           "file_select");
		 keyf_set(0, "[F03]",         "file_select");

		 keyf_set(0, "[ESC]O",        "file_open");
		 keyf_set(0, "[ESC]C",        "file_close");
		 keyf_set(0, "[ESC]L",        "file_copen");
		 keyf_set(0, "[ESC]S",        "file_save");
		 keyf_set(0, "[ESC]Q",        "file_quit");

		 keyf_set(0, "[ESC]P",        "file_rename");
		 keyf_set(0, "[ESC]W",        "file_profile");

		 keyf_set(0, "[ESC]U",        "file_undo");
		 keyf_set(0, "[ESC]I",        "file_insert");
		 keyf_set(0, "[ESC]X",        "file_aclose");


		 keyf_set(0, "^E",            "cursor_up");
		 keyf_set(0, "[UP]",          "cursor_up");
		 keyf_set(0, "^X",            "cursor_down");
		 keyf_set(0, "[DOWN]",        "cursor_down");
		 keyf_set(0, "^S",            "cursor_left");
		 keyf_set(0, "[LEFT]",        "cursor_left");
		 keyf_set(0, "^D",            "cursor_right");
		 keyf_set(0, "[RIGHT]",       "cursor_right");
		 keyf_set(0, "^A",            "cursor_tkprev");
		 keyf_set(0, "^F",            "cursor_tknext");
		 keyf_set(0, "^QS",           "cursor_sleft");
		 keyf_set(0, "[HOME]",        "cursor_sleft");
		 keyf_set(0, "^QD",           "cursor_sright");
		 keyf_set(0, "[END]",         "cursor_sright");
		 keyf_set(0, "^W",            "cursor_rup");
		 keyf_set(0, "^Z",            "cursor_rdown");
		 keyf_set(0, "^R",            "cursor_pup");
		 keyf_set(0, "[PGUP]",        "cursor_pup");
		 keyf_set(0, "^C",            "cursor_pdown");
		 keyf_set(0, "[PGDN]",        "cursor_pdown");
		 keyf_set(0, "^QE",           "cursor_sup");
		 keyf_set(0, "^QX",           "cursor_sdown");
		 keyf_set(0, "^QR",           "cursor_top");
		 keyf_set(0, "^QC",           "cursor_bottom");


		 keyf_set(0, "^QP",           "jump_before");
		 keyf_set(0, "^QM",           "jump_mark");
		 keyf_set(0, "^QJ",           "Jump_line");

		 keyf_set(0, "^K1",           "jump_Mark 1");
		 keyf_set(0, "^K2",           "jump_Mark 2");
		 keyf_set(0, "^K3",           "jump_Mark 3");
		 keyf_set(0, "^K4",           "jump_Mark 4");

		 keyf_set(0, "^Q1",           "Jump_before 1");
		 keyf_set(0, "^Q2",           "jump_before 2");
		 keyf_set(0, "^Q3",           "Jump_before 3");
		 keyf_set(0, "^Q4",           "Jump_before 4");

		 keyf_set(0, "^QG",           "jump_tag");



		 keyf_set(0, "[CR]",          "line_cr");

		 keyf_set(0, "^U",            "char_undo");
		 keyf_set(0, "^P",            "char_input");

		 keyf_set(0, "^N",            "line_cr");
		 keyf_set(0, "^QL",           "line_undo");


		 keyf_set(0, "^H",            "del_bs");
		 keyf_set(0, "[BS]",          "del_bs");
		 keyf_set(0, "^G",            "del_char");
		 keyf_set(0, "[DEL]",         "del_char");
		 keyf_set(0, "^QH",           "del_tkprev");
		 keyf_set(0, "^T",            "del_tknext");
		 keyf_set(0, "^QT",           "del_sright");
		 keyf_set(0, "^QY",           "del_sleft");


		 keyf_set(0, "^B",            "block_start");
		 keyf_set(0, "[F10]",         "block_start");
		 keyf_set(0, "^Y",            "block_cut");
		 keyf_set(0, "[F08]",         "block_cut");
		 keyf_set(0, "^J",            "block_paste");
		 keyf_set(0, "[F09]",         "block_paste");
		 keyf_set(0, "^KK",           "block_yanc");
		 keyf_set(0, "^KC",           "block_copy");
		 keyf_set(0, "^KY",           "block_kill");
		 keyf_set(0, "^QB",           "block_chlast");

		 keyf_set(0, "^KD",           "block_dup");


		 keyf_set(0, "^@",            "search_paging");

		 keyf_set(0, "^QF",           "search_in");
		 keyf_set(0, "[F06]",         "search_in");
		 keyf_set(0, "^QA",           "search_repl");
		 keyf_set(0, "[F07]",         "search_repl");
		 keyf_set(0, "^QO",           "search_repl_redo");

		 keyf_set(0, "^L",            "search_getword");
		 keyf_set(0, "[F05]",         "search_getword");



		 keyf_set(0, "^_",            "misc_kmacro");
		 keyf_set(0, "^V",            "opt_set OverWrite");
		 keyf_set(0, "[INS]",         "opt_set OverWrite");
		 keyf_set(0, "[ESC]E",        "misc_exec");

		 keyf_set(0, "[F01]",         "menu_file");
		 keyf_set(0, "[F04]",         "menu_opt");
		 keyf_set(0, "^KI",           "opt_tab");

		 keyf_set(0, "[ESC]D",        "misc_redraw");
		}

	n=keydef_num(1);
	if (n==0)
		{
		 keyf_set(1, "[ESC]",         "sysEscape");
		 keyf_set(1, "[CR]",          "sysReturn");

		 keyf_set(1, "^E",            "sysCursorup");
		 keyf_set(1, "[UP]",          "sysCursorup");
		 keyf_set(1, "^X",            "sysCursordown");
		 keyf_set(1, "[DOWN]",        "sysCursordown");
		 keyf_set(1, "^S",            "sysCursorleft");
		 keyf_set(1, "[LEFT]",        "sysCursorleft");
		 keyf_set(1, "^D",            "sysCursorright");
		 keyf_set(1, "[RIGHT]",       "sysCursorright");

		 keyf_set(1, "^H",            "sysBackspace");
		 keyf_set(1, "[BS]",          "sysBackspace");
		 keyf_set(1, "^G",            "sysDeletechar");
		 keyf_set(1, "[DEL]",         "sysDeletechar");
		 keyf_set(1, "^P",            "sysCntrlinput");

		 keyf_set(1, "^R",            "sysScrolldown");
		 keyf_set(1, "^C",            "sysScrollup");
		 keyf_set(1, "^W",            "sysRollup");
		 keyf_set(1, "^Z",            "sysRolldown");

		 keyf_set(1, "^QE",           "sysCursorupside");
		 keyf_set(1, "^QX",           "sysCursordownside");
		 keyf_set(1, "^QS",           "sysCursorleftside");
		 keyf_set(1, "^QD",           "sysCursorrightside");
		 keyf_set(1, "^QR",           "sysCursortopside");
		 keyf_set(1, "^QC",           "sysCursorendside");
		}

	n=keydef_num(2);
	if (n==0)
		{
		 keyf_set(2, "[ESC]",         "effEscape");
		 keyf_set(2, "^E",            "effCursorUp");
		 keyf_set(2, "[UP]",          "effCursorUp");
		 keyf_set(2, "^X",            "effCursorDown");
		 keyf_set(2, "[DOWN]",        "effCursorDown");
		 keyf_set(2, "^S",            "effWindowChange");
		 keyf_set(2, "[LEFT]",        "effWindowChange");
		 keyf_set(2, "^D",            "effWindowChange");
		 keyf_set(2, "[RIGHT]",       "effWindowChange");
		 keyf_set(2, "[tab]",         "effWindowChange");
		 keyf_set(2, "w",             "effWindowNumChange");
		 keyf_set(2, "@",             "effReRead");
		 keyf_set(2, "r",             "effRename");
		 keyf_set(2, "k",             "effMkdir");
		 keyf_set(2, "^R",            "effPageUp");
		 keyf_set(2, "[PPAGE]",       "effPageUp");
		 keyf_set(2, "^C",            "effPageDown");
		 keyf_set(2, "[NPAGE]",       "effPageDown");
		 keyf_set(2, "^W",            "effRollUp");
		 keyf_set(2, "^Z",            "effRollDown");
		 keyf_set(2, "l",             "effChangeDir");
		 keyf_set(2, "/",             "effChangeDir /");
		 keyf_set(2, "\\",            "effChangeDir /");
		 keyf_set(2, "~",             "effChangeDir ~");
		 keyf_set(2, "q",             "effChangeDir ~");
		 keyf_set(2, "[BS]",          "effChangeDir ..");
		 keyf_set(2, "[CR]",          "effReturn");
		 keyf_set(2, "c",             "effFileCp");
		 keyf_set(2, "m",             "effFileMv");
		 keyf_set(2, "d",             "effFileRm");
		 keyf_set(2, "[SPACE]",       "effMarkChange");
		 keyf_set(2, "*",             "effMarkChangeAll");
		 keyf_set(2, "x",             "effExec");
		 keyf_set(2, "h",             "effExec");
		}
}

void	sysinfo_optset()
{
	const	char	*p;
	bool	f;


	p= gval_get(sysinfo.vp_def, "tabcode");
	if (p==NULL)
		sysinfo.tabcode=-1; else
		sysinfo.tabcode=*p;

	p=gval_get(sysinfo.vp_def, "tabstop");
	if (p!=NULL)
		{
		 sysinfo.tabstop= atoi(p);
		 if (sysinfo.tabstop<= 0)
		 	{
		 	 char	tmp[20+1];
 
			 sysinfo.tabstop = 8;
			 sprintf(tmp,"%d",sysinfo.tabstop);
			 gval_set(sysinfo.vp_def, "tabstop",tmp);
			}
	}

	sysinfo.japanesef  = gval_istrue(sysinfo.vp_def, "Japanese");
	sysinfo.crmarkf    = gval_istrue(sysinfo.vp_def, "crmark");
	sysinfo.tabmarkf   = gval_istrue(sysinfo.vp_def, "tabmark");
	sysinfo.backupf    = gval_istrue(sysinfo.vp_def, "backup");
	sysinfo.autoindentf= gval_istrue(sysinfo.vp_def, "autoindent");
	sysinfo.nocasef    = gval_istrue(sysinfo.vp_def, "nocase");
	sysinfo.overwritef = gval_istrue(sysinfo.vp_def, "overwrite");
	sysinfo.freecursorf= gval_istrue(sysinfo.vp_def, "freecursor");
	sysinfo.numberf    = gval_istrue(sysinfo.vp_def, "number");

	f=(term_getmode()& TM_ansicolor)!=0;
	if (gval_istrue(sysinfo.vp_def, "AnsiColor"))
		{
		 if (!f)
		 	term_setmode(term_getmode()| TM_ansicolor);
		} else
		{
		 if (f)
		 	term_setmode(term_getmode()& ~TM_ansicolor);
		}


	sysinfo.c_block    =term_cftocol(gval_get(sysinfo.vp_def, "col_block"));
	sysinfo.c_linenum  =term_cftocol(gval_get(sysinfo.vp_def, "col_linenum"));

	sysinfo.c_ctrl     =term_cftocol(gval_get(sysinfo.vp_def, "col_ctrl"));
	sysinfo.c_crmark   =term_cftocol(gval_get(sysinfo.vp_def, "col_crmark"));
	sysinfo.c_crmark.fc=sysinfo.c_ctrl.fc;
	sysinfo.c_crmark.bc=sysinfo.c_ctrl.bc;

	sysinfo.c_sysmsg   =term_cftocol(gval_get(sysinfo.vp_def, "col_sysmsg"));
	sysinfo.c_search   =term_cftocol(gval_get(sysinfo.vp_def, "col_search"));
	sysinfo.c_menuc    =term_cftocol(gval_get(sysinfo.vp_def, "col_menuc"));
	sysinfo.c_menun    =term_cftocol(gval_get(sysinfo.vp_def, "col_menun"));
	sysinfo.c_eff_dirc =term_cftocol(gval_get(sysinfo.vp_def, "col_eff_dirc"));
	sysinfo.c_eff_dirn =term_cftocol(gval_get(sysinfo.vp_def, "col_eff_dirn"));
	sysinfo.c_eff_normc=term_cftocol(gval_get(sysinfo.vp_def, "col_eff_normc"));
	sysinfo.c_eff_normn=term_cftocol(gval_get(sysinfo.vp_def, "col_eff_normn"));
}

void	opt_set(const char *s,const char *t)
{
	if (t!=NULL)
		gval_set(sysinfo.vp_def, s, t); else
		{
		 if (gval_istrue(sysinfo.vp_def, s))
		 	gval_set(sysinfo.vp_def, s,"false"); else
		 	gval_set(sysinfo.vp_def, s,"true");
		}
	sysinfo_optset();

}

SHELL	void	op_opt_set()
{
	int 	n;

	n=keyf_numarg();
	if (n>=1)
		opt_set(keyf_getarg(0), keyf_getarg(1));
}


void	SetDefaultOption()
{
	gval_set(sysinfo.vp_def, "TabStop","8");
	gval_set(sysinfo.vp_def, "tabcode","<");
	gval_set(sysinfo.vp_def, "Japanese","true");
//	gval_set(sysinfo.vp_def, "FreeCursor","true");
//	gval_set(sysinfo.vp_def, "CrMark","true");
	gval_set(sysinfo.vp_def, "AutoIndent","true");
	gval_set(sysinfo.vp_def, "ansicolor","true");

	gval_set(sysinfo.vp_def, "col_block","R");
	gval_set(sysinfo.vp_def, "col_linenum","4");
	gval_set(sysinfo.vp_def, "col_ctrl","4");
	gval_set(sysinfo.vp_def, "col_crmark","4");
	gval_set(sysinfo.vp_def, "col_sysmsg","B");
	gval_set(sysinfo.vp_def, "col_search","T");
	gval_set(sysinfo.vp_def, "col_menuc","6R");
	gval_set(sysinfo.vp_def, "col_eff_dirc","3R");
	gval_set(sysinfo.vp_def, "col_eff_dirn","6");
	gval_set(sysinfo.vp_def, "col_eff_normc","3R");
}



char	*dval_parse(char *s, char *t)
{
	char	c;
	char	*p, buf[MAXLINESTR+1];

	c=' ';
	p=buf;
	while (*s!='\0'&& *s!=c)
		{
		 if (*s=='(')
		 	{
		 	 c=')';
		 	 ++s;
		 	 continue;
		 	}
		 if (*s=='{')
		 	{
		 	 c='}';
		 	 ++s;
		 	 continue;
			}
		 *p++=*s++;
		}
	*p='\0';
	if (*s!='\0')
		++s;

	switch(*buf)
		{
	 case '?':
	 	 *t++=(char)strtol(buf+1, NULL, 16);
	 	 *t='\0';
	 	 return s;

	 case '*':
	 	 p=getenv(buf+1);
	 	 break;
	 default:
	 	 p=gval_get(sysinfo.vp_def, buf);
	 	}
//fprintf(stderr, " {%s} \n",p);
	if (p!=NULL)
		strcpy(t, p);
	return s;
}

#define	issp(c)		((c)==' '|| (c)=='\t')
#define	isdelim(c)	((c)==':'|| (c)=='=')

char	*define_fgets(FILE *fp, char *buf)
{
	char	*p;

	for (;;)
		{
		 if (fgets(buf, MAXLINESTR, fp)==NULL)
		 	return NULL;
		 p=strpbrk(buf, "#;\r\n");
		 if (p!=NULL)
		 	{
		 	 while (p>buf&& issp(*(p-1)))
		 	 	--p;
		 	 *p='\0';
		 	}
		 p=buf;
		 while(isspace(*p))
		 	++p;
		 if (*p!='\0')
		 	return p;
		}
}


#define DEF_nbuf	2
bool	define_read(char *path)
{
	FILE	*fp;
	int 	region, mode;
	char	zone[MAXLINESTR+1];
	char	em;
	int 	n;
	bool	qf;

	char	buf[MAXLINESTR+1];
	char	s_buf[DEF_nbuf][MAXLINESTR+1];
	char	*p,*q;

	fp=fopen(path,"r");
	if (fp==NULL)
		return FALSE;

	mode='\0';
	for (;;)
		{
		 p=define_fgets(fp, buf);
		 if (p==NULL)
		 	break;
//fprintf(stderr, "[%s]\n",p);

		 qf=FALSE;
		 em=0;
		 n=0;
		 q=s_buf[0];
		 if (*p=='!')
		 	{
		 	 ++p;
		 	 if (isalpha(*p)|| *p=='<')
		 	 	em=*p++; else
		 	 	--p;
		 	}

		 for (;;)
		 	{
// !{ !}

			 if (isdelim(*p)|| *p=='\0')
			 	{
			 	 while (q>s_buf[n]&& issp(*(q-1)))
			 	 	--q;
			 	 *q='\0';
//fprintf(stderr, " %d:[%s]\n",n, s_buf[n]);

			 	 if (++n>=DEF_nbuf|| *p=='\0')
			 	 	break;
			 	 q=s_buf[n];
			 	 ++p;
			 	 while (issp(*p))
			 	 	++p;
			 	}

		 	 if (*p=='\"')
		 	 	qf= !qf;
		 	 if (!qf&& *p=='$')
		 	 	{
		 	 	 p=dval_parse(p+1, q);
		 	 	 q=strchr(q,'\0');
		 	 	}
		 	 if (!qf&& *p=='!')
		 	 	{
		 	 	 ++p;
		 	 	 if (*p=='\0')
		 	 	 	continue;
		 	 	}
		 	 *q++=*p++;
		 	}

		 if (isalpha(em))
		 	{
		 	 mode=em;
		 	 if (n>=2)
		 	 	strcpy(zone, s_buf[1]); else
		 	 	*zone='\0';
		 	 continue;
		 	}

		 if (n<2)
		 	continue;
		 if (em=='<')
		 	{
		 	 define_read(s_buf[1]);
		 	 continue;
		 	}

		 switch(toupper(mode))
		 	{
		  case 'D':
//fprintf(stderr, " D:[%s][%s]\n",s_buf[0], s_buf[1]);
		 	 keys_set(s_buf[0], s_buf[1]);
		 	 break;

		  case 'K':
		 	 region=0;
		 	 sprintf(buf, "op_%s%s", zone, s_buf[1]);
		 	 if (strcasecmp(zone, "sys")==0)
		 	 	region=1;
		 	 if (strcasecmp(zone, "eff")==0)
		 	 	region=2;
		 	 keyf_set(region, s_buf[0], buf);
//fprintf(stderr, " KS:%d [%s][%s]\n",region, s_buf[0], buf);
		 	 break;

		  default:
		 	 gval_set(sysinfo.vp_def, s_buf[0], s_buf[1]);
		 	}
		}

	fclose(fp);
	return TRUE;
}


void	option_set_proc(int a,mitem_t *mip,void *vp)	// !!!!
{
	char	*opt_kc[]={"euc","jis","sjis"};
	char	*opt_rm[]={"lf","crlf","cr"};

	switch(a)
		{
	 case 0:
	 	 sprintf(mip->str, "%s%-12s", OPT_NUMBER_MSG, (gval_istrue(sysinfo.vp_def, "number") ? "ON":"OFF"));
	 	 break;
	 case 1:
	 	 sprintf(mip->str, "%s%-12s", OPT_INPUT_MODE_MSG, (gval_istrue(sysinfo.vp_def, "overwrite") ? "ON":"OFF"));
	 	 break;
	 case 2:
	 	 sprintf(mip->str, "%s%-12s", OPT_CURSOR_MODE_MSG, (gval_istrue(sysinfo.vp_def, "freecursor") ? "ON":"OFF"));
	 	 break;
	 case 3:
	 	 sprintf(mip->str, "%s%-12s", OPT_AUTOINDENT_MODE_MSG, (gval_istrue(sysinfo.vp_def, "autoindent") ? "ON":"OFF"));
	 	 break;
	 case 4:
	 	 sprintf(mip->str, "%s%-12s", OPT_BACKUP_MSG, (gval_istrue(sysinfo.vp_def, "backup") ? "ON":"OFF"));
	 	 break;
	 case 5:
	 	 sprintf(mip->str, "%s%-12s", OPT_TAB_MARK_MSG, (gval_istrue(sysinfo.vp_def, "tabmark") ? "ON":"OFF"));
	 	 break;
	 case 6:
	 	 sprintf(mip->str, "%s%-12s", OPT_TAB_SPACE_MSG, (gval_istrue(sysinfo.vp_def, "tab_space") ? "ON":"OFF"));
	 	 break;
	 case 7:
	 	 sprintf(mip->str, "%s%-12s", OPT_CR_MARK_MSG, (gval_istrue(sysinfo.vp_def, "crmark") ? "ON":"OFF"));
	 	 break;
	 case 8:
	 	 sprintf(mip->str, "%s%-12s", OPT_SEARCH_CH_MSG, (gval_istrue(sysinfo.vp_def, "nocase") ? "ON":"OFF"));
	 	 break;
	 case 9:
	 	 sprintf(mip->str, "%s%-12s", OPT_MESSAGE_MSG, (gval_istrue(sysinfo.vp_def, "Japanese")?"ON":"OFF"));
	 	 break;
	 case 10:
	 	 sprintf(mip->str, "%s%-12s", OPT_KANJICODE_MSG,opt_kc[ef[CurrentFileNo].kc]);
	 	 break;
	 case 11:
	 	 sprintf(mip->str, "%s%-12s", "R)CR/LF             : ",opt_rm[ef[CurrentFileNo].rm]);
	 	 break;
	 case 12:
	 	 sprintf(mip->str, "%s%-12d", OPT_TAB_STOP_MSG, atoi(gval_get(sysinfo.vp_def, "TabStop")));
	 	 break;
	 	}
}


void	SeeOption()
{
	menu_t	menu;
	char	buff[MAXLINESTR+1];
	int 	res;

	do {
		menu_iteminit(&menu);
		menu_itemmake(&menu,option_set_proc,13,NULL);
		res=menu_select(&menu);
		menu_itemfin(&menu);

		switch(res) {
		case 0:
			opt_set("number", NULL);
			break;
		case 1:
			opt_set("overwrite", NULL);
			break;
		case 2:
			opt_set("freecursor", NULL);
			break;
		case 3:
			opt_set("autoindent", NULL);
			break;
		case 4:
			opt_set("backup", NULL);
			break;
		case 5:
			opt_set("tabmark", NULL);
			break;
		case 6:
			opt_set("tabspace", NULL);
			break;
		case 7:
			opt_set("crmark", NULL);
			break;
		case 8:
			opt_set("NoCase", NULL);
			break;
		case 9:
			opt_set("Japanese", NULL);
			break;
		case 10:
			op_opt_kanji();
			break;
		case 11:
			op_opt_retmode();
			break;
		case 12:
			op_opt_tab();
		}
		csrse.uf=TRUE;
		CrtDrawAll();
	} while (res != -1);
}

SHELL	void	op_menu_opt()
{
	SeeOption();
}

SHELL	void	op_opt_kanji()
{
	++ef[CurrentFileNo].kc;
	if (ef[CurrentFileNo].kc>=3)
		ef[CurrentFileNo].kc=0;
	ef[CurrentFileNo].cf=TRUE;
}

SHELL	void	op_opt_retmode()
{
	++ef[CurrentFileNo].rm;
	if (ef[CurrentFileNo].rm>=3)
		ef[CurrentFileNo].rm=0;
	ef[CurrentFileNo].cf=TRUE;
}

SHELL	void	op_opt_tab()
{
	char	tmp[20+1];

	sysinfo.tabstop= sysinfo.tabstop ==8?4:8;
	sprintf(tmp,"%d",sysinfo.tabstop);
	gval_set(sysinfo.vp_def, "tabstop", tmp);
	csrse.uf=TRUE;
}

